/*
 * The_xmloperator_project Software License, Version 1.7
 *
 * Copyright (c) 2000 - 2003 The_xmloperator_project.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *      "This product includes or uses software developped
 *       by The_xmloperator_project (http://www.xmloperator.net/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. Products derived from this software may not be called "xmloperator",
 *    nor may "xmloperator" appear in their name, without prior written
 *    permission. For written permission, please contact
 *    the xmloperator project administrator.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE_XMLOPERATOR_PROJECT OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * Further information can be found on the project's site
 * (http://www.xmloperator.net/).
 */
package org.xmloperator.framework.control.global;

import java.awt.Component;

import org.w3c.dom.DocumentType;

import org.xmloperator.framework.document.doctype.DTDInfo;
import org.xmloperator.framework.document.doctype.DocumentTypeInfo;
import org.xmloperator.framework.document.transform.TransformerInfo;

public interface GlobalOptionsControl {

  // Schema relative methods.

  public abstract void buildDTDFromDTDXML(
    String dTDXMLSystemId, String dTDSystemId,
    boolean arePatternsTranslatedToParameterEntityDeclarations);

  public abstract void buildRNGSimpleSyntaxFromFullSyntax(
    String rNGFullSyntaxSystemId, String rNGSimpleSyntaxSystemId,
    int simplificationType);

  // Document type info relative methods.

  public abstract DocumentTypeInfo newDocumentType();

  public abstract DocumentTypeInfo newDocumentType(String documentTypeName,
    DocumentType doctype);

  public abstract DocumentTypeInfo newDocumentType(
    DocumentTypeInfo documentTypeInfoSource);

  public abstract void editDocumentTypeInfo(
    String documentTypeName, String documentTypeAdditionalKey);

  public abstract void removeDocumentType(
    String documentTypeName, String documentTypeAdditionalKey);

  // Transformer info relative methods.

  public abstract TransformerInfo newTransformer();

  public abstract TransformerInfo newTransformer(
    TransformerInfo transformerInfoSource);

  public abstract void editTransformerInfo(String transformerName);

  public abstract void removeTransformer(String transformerName);
}
