/*
 * The_xmloperator_project Software License, Version 1.7
 *
 * Copyright (c) 2000 - 2003 The_xmloperator_project.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *      "This product includes or uses software developped
 *       by The_xmloperator_project (http://www.xmloperator.net/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. Products derived from this software may not be called "xmloperator",
 *    nor may "xmloperator" appear in their name, without prior written
 *    permission. For written permission, please contact
 *    the xmloperator project administrator.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE_XMLOPERATOR_PROJECT OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * Further information can be found on the project's site
 * (http://www.xmloperator.net/).
 */
package org.xmloperator.option.part;

import org.xmloperator.framework.option.part.OptionPartType;
import org.xmloperator.framework.option.part.OptionPart;
import org.xmloperator.framework.option.part.ThreeStateOptionPart;
import org.xmloperator.option.part.ThreeStateOptionPartType;
  // reciprocal import
import org.xmloperator.option.part.OptionPartImpl;

public final class ThreeStateOptionPartImpl extends OptionPartImpl
  implements ThreeStateOptionPart {
  private static final String UNDEFINED_VALUE = "";
  private static final String FALSE_VALUE = "FALSE";
  private static final String TRUE_VALUE = "TRUE";
  private int value;

  public ThreeStateOptionPartImpl(OptionPartType optionPartType) {
    super(optionPartType);
    value = ThreeStateOptionPart.UNDEFINED;
  }

  public int getDefaultValue() {
    return ((ThreeStateOptionPartType)getOptionPartType()).getDefaultValue();
  }

  ////////////////////////////
  // OptionPart implementation
  ////////////////////////////

  public final String getValue() {
    return value == ThreeStateOptionPart.FALSE ? FALSE_VALUE :
      value == ThreeStateOptionPart.TRUE ? TRUE_VALUE : UNDEFINED_VALUE;
  }

  public final void setValue(String value) {
    this.value = value != null ?
      value.equals(TRUE_VALUE) ? ThreeStateOptionPart.TRUE :
      value.equals(FALSE_VALUE) ? ThreeStateOptionPart.FALSE :
      ThreeStateOptionPart.UNDEFINED : ThreeStateOptionPart.UNDEFINED;
  }

  //////////////////////////////////////
  // ThreeStateOptionPart implementation
  //////////////////////////////////////

  public final int getThreeStateValue() {
    return value;
  }

  public final void setThreeStateValue(int value) {
    this.value = value == ThreeStateOptionPart.FALSE
      || value == ThreeStateOptionPart.TRUE ?
      value : ThreeStateOptionPart.UNDEFINED;
  }
}
