/*
 * The_xmloperator_project Software License, Version 1.7
 *
 * Copyright (c) 2000 - 2003 The_xmloperator_project.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *      "This product includes or uses software developped
 *       by The_xmloperator_project (http://www.xmloperator.net/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. Products derived from this software may not be called "xmloperator",
 *    nor may "xmloperator" appear in their name, without prior written
 *    permission. For written permission, please contact
 *    the xmloperator project administrator.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE_XMLOPERATOR_PROJECT OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * Further information can be found on the project's site
 * (http://www.xmloperator.net/).
 */
package org.xmloperator.transform;

import java.util.Hashtable;
import java.util.Properties;

import javax.xml.transform.TransformerException;
import javax.xml.transform.Source;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.Result;
import javax.xml.transform.URIResolver;
import javax.xml.transform.ErrorListener;
import javax.xml.transform.Transformer;

import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.w3c.dom.Document;

import org.xmloperator.framework.document.id.IdBrowser;

public abstract class AbstractTransformer extends Transformer {
  protected IdBrowser idBrowser = null;
  protected final Hashtable parameters = new Hashtable();

  public final void setIdBrowser(IdBrowser idBrowser) {
    this.idBrowser = idBrowser;
  }

  /*
  protected abstract void transform(
      Document sourceDocument, Result outputTarget) throws TransformerException;

  public final void transform(Source xmlSource, Result outputTarget)
      throws TransformerException {
    if (!(xmlSource instanceof DOMSource))
      throw new IllegalArgumentException();
    Node sourceNode = ((DOMSource)xmlSource).getNode();
    if (!(sourceNode instanceof Document))
      throw new IllegalArgumentException();
    this.transform((Document)sourceNode, outputTarget);
  }
  */

  public final void setParameter(String name, Object value) {
    parameters.put(name, value);
  }

  public final Object getParameter(String name) {
    return parameters.get(name);
  }

  public final void clearParameters() {
    parameters.clear();
  }

  public void setURIResolver(URIResolver resolver) {
  }

  public URIResolver getURIResolver() {
    return null;
  }

  public final void setOutputProperties(Properties oformat)
      throws IllegalArgumentException {
  }

  public final Properties getOutputProperties() {
    return null;
  }

  public final void setOutputProperty(String name, String value)
      throws IllegalArgumentException {
  }

  public final String getOutputProperty(String name)
      throws IllegalArgumentException {
    return null;
  }

  public final void setErrorListener(ErrorListener listener)
      throws IllegalArgumentException {
  }

  public final ErrorListener getErrorListener() {
    return null;
  }
}
