/*
 * The_xmloperator_project Software License, Version 1.7
 *
 * Copyright (c) 2000 - 2003 The_xmloperator_project.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *      "This product includes or uses software developped
 *       by The_xmloperator_project (http://www.xmloperator.net/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. Products derived from this software may not be called "xmloperator",
 *    nor may "xmloperator" appear in their name, without prior written
 *    permission. For written permission, please contact
 *    the xmloperator project administrator.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE_XMLOPERATOR_PROJECT OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * Further information can be found on the project's site
 * (http://www.xmloperator.net/).
 */
package org.xmloperator.util.view;

import java.awt.Container;
import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Event;
import java.awt.AWTEvent;
import java.awt.event.KeyEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.util.ResourceBundle;
import javax.swing.JComponent;
import javax.swing.KeyStroke;
import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.ImageIcon;
import javax.swing.border.EmptyBorder;

import org.xmloperator.framework.view.resource.Label;

public abstract class AboutBox extends JDialog {
  protected final ResourceBundle viewResource =
    ResourceBundle.getBundle(Label.CLASS);

  public AboutBox(Frame parent) {
    super(parent, true);
    this.enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    this.setTitle(viewResource.getString(Label.A_PROPOS));
    this.setResizable(false);
    JPanel voletContenu = new JPanel(new BorderLayout());
    this.getContentPane().add(voletContenu);
    voletContenu.setLayout(new BorderLayout());
    final ActionListener disposeActionListener =
      new ActionListener() {
        public void actionPerformed(ActionEvent event) {
          dispose();
        }
      };
    voletContenu.registerKeyboardAction(disposeActionListener, "ESCAPE",
      KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0),
      JComponent.WHEN_IN_FOCUSED_WINDOW);
    JPanel voletMessage = new JPanel(new BorderLayout());
    // Volet icne
    JPanel voletIcone = new JPanel(new FlowLayout());
    voletIcone.setBorder(new EmptyBorder(10, 10, 10, 10));
    JLabel imageControl = new JLabel();
    ImageIcon imageIcon = imageIcon();
    if (imageIcon != null)
      imageControl.setIcon(imageIcon);
    voletIcone.add(imageControl, null);
    voletMessage.add(voletIcone, BorderLayout.WEST);
    // Volet propos
    String[] propos = propos();
    JPanel voletPropos = new JPanel(new GridLayout(propos.length, 1));
    voletPropos.setBorder(new EmptyBorder(10, 40, 10, 10));
    for (int k = 0; k < propos.length; k++)
      voletPropos.add(new JLabel(propos[k]));
    voletMessage.add(voletPropos, BorderLayout.CENTER);
    voletContenu.add(voletMessage, BorderLayout.NORTH);
    // Volet bouton
    JPanel voletBouton = new JPanel(new FlowLayout());
    final JButton boutonValider =
      new JButton(viewResource.getString(Label.VALIDER));
    boutonValider.setMnemonic(viewResource.getString(Label.MNEMO
      + Label.VALIDER).charAt(0));
    boutonValider.addActionListener(disposeActionListener);
    voletBouton.add(boutonValider, null);
    voletContenu.add(voletBouton, BorderLayout.SOUTH);
    pack();
  }

  protected void processWindowEvent(WindowEvent event) {
    if(event.getID() == WindowEvent.WINDOW_CLOSING)
      dispose();
    else
      super.processWindowEvent(event);
  }

  // A surcharger
  protected ImageIcon imageIcon() {
    return null;
  }

  // A surcharger
  protected String[] propos() {
    return new String[] {};
  }
}
