/*
 * The_xmloperator_project Software License, Version 1.7
 *
 * Copyright (c) 2000 - 2003 The_xmloperator_project.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *      "This product includes or uses software developped
 *       by The_xmloperator_project (http://www.xmloperator.net/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. Products derived from this software may not be called "xmloperator",
 *    nor may "xmloperator" appear in their name, without prior written
 *    permission. For written permission, please contact
 *    the xmloperator project administrator.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE_XMLOPERATOR_PROJECT OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * Further information can be found on the project's site
 * (http://www.xmloperator.net/).
 */
package org.xmloperator.util.view;

import java.util.List;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyAdapter;
import java.awt.Frame;
import java.awt.BorderLayout;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.border.EmptyBorder;

import org.xmloperator.framework.view.dialog.DialogSelection;
import org.xmloperator.util.view.DialogModal;

public class DialogSelectionImpl extends DialogModal
    implements DialogSelection {
  protected final JLabel labelInvite = new JLabel();
  protected final JPanel panelSelection = new JPanel(new BorderLayout());
  protected final JComboBox comboBoxSelection = new JComboBox();

  public DialogSelectionImpl(Frame parent) {
    super(parent);
    this.setResizable(false);
    panelSelection.setBorder(new EmptyBorder(4, 4, 4, 4));
    panelSelection.add(this.labelInvite, BorderLayout.WEST);
    this.comboBoxSelection.addActionListener(
      new ActionListener() {
        public void actionPerformed(ActionEvent event) {
          comboBoxSelection_actionPerformed();
        }
      });
    this.comboBoxSelection.addKeyListener(this.okOnEnterKeyListener);
    panelSelection.add(this.comboBoxSelection);
    contentPanel.add(panelSelection);
    // <code>pack()</code> restant  faire.
  }

  private void comboBoxSelection_actionPerformed() {
    buttonOK.setEnabled(isSelectionValid());
  }

  protected boolean isSelectionValid() {
    return true;
  }

  public void setContentFont(Font font) {
    this.comboBoxSelection.setFont(font);
  }

  public void setInvite(String invite) {
    try {
      invite = viewResource.getString(invite);
    }
    catch (Exception exception) {
    }
    this.labelInvite.setText(invite + " : ");
    this.pack();
  }

  /////////////////////////////////
  // DialogSelection implementation
  /////////////////////////////////

  public void setItemList(List itemList) {
    Object[] items = new Object[itemList.size()];
    itemList.toArray(items);
    this.setItems(items);
  }

  public void setItems(Object[] items) {
    if (this.isVisible())
      throw new IllegalStateException();
    if (items.length == 0)
      throw new IllegalArgumentException();
    if (this.comboBoxSelection.getItemCount() != 0)
      this.comboBoxSelection.removeAllItems();
    for (int k = 0; k < items.length; k++)
      this.comboBoxSelection.addItem(items[k]);
    this.comboBoxSelection.setSelectedIndex(0);
    this.pack();
  }

  public Object getSelectedItem() {
    return comboBoxSelection.getSelectedItem();
  }
}
